class Blade_server_switch_information
  def initialize(servicetag,serverinfo,swinfo)
    @nodename=servicetag
    @sinfo=serverinfo
    @switchinfo=swinfo
  end

  def identify_switch_ports(swinfo, logger, server_nic_type, configured_blade_switch_facts)
    serviceTag=@nodename
    serverModel=@sinfo['servermodel']
    idracIp=@sinfo['idrac_ip']
    idracusername=@sinfo['idrac_username']
    idracpassword=@sinfo['idrac_password']
    chassisip=@sinfo['chassis_ip']
    chassisusername=@sinfo['chassis_username']
    chassispassword=@sinfo['chassis_password']
    slot=@sinfo['slot_num']
    quaterBladeModelList = [ "M420", "M430" ]
    halfBladeModelList = [ "M620", "M520", "M630", "M530" ]
    fullBladeModelList = [ "M820", "M830" ]

    fx2_quater_blade_model_list = ['FC420', 'FC430']
    fx2_half_blade_model_list = ['FC620', 'FC630']
    fx2_full_blade_model_list = ['FC820','FC830']

    switchlist = []
    retVal = []

    index = 0
    switchlist = @sinfo['ioaips']
    switch_certs = Array.new
      
    logger.debug("server_nic_type: #{server_nic_type.inspect}")
    # Eliminate the switches which are not discovered
    swinfo.each do |switch_cert_name,switch_info|
      switch_certs.push switch_cert_name
    end
    
    updated_switch_list = Array.new
    logger.debug "IOM Info: Switch Certs #{switch_certs}"
    logger.debug "IOM IP list: #{switchlist}"
    logger.debug "IOM Model list: #{@sinfo['ioa_models']}"

    switchlist.each_with_index do |ioa_ip, ioa_index|
      logger.debug "temp_cert_name: #{ioa_ip}"
      if @sinfo['ioa_models'][ioa_index].match(/FEX/)
        ioa_ip = ASM::Util.fetch_cisco_nexus_fex(@sinfo['ioa_service_tags'][ioa_index],@sinfo['ioaslots'][ioa_index])
      end
      if switch_certs.include?(ioa_ip)
        logger.debug "Matched with certificate"
        updated_switch_list.push ioa_ip
      end
    end
      
    
    logger.debug "A-- switchlist ::: #{updated_switch_list}"
    updated_switch_list.each_with_index do |ioa,ioa_index|
      if ioa.match(/cisconexus/)
        ioa_index == 0 ? ioaslot = "A1" : ioaslot = "A2"
      else
        ioaslot = configured_blade_switch_facts[ioa]['fabric_id']
      end

      logger.debug"IOA Slot information: #{ioaslot}"
      index +=1
      logger.debug "IOA Slot : #{ioaslot}"
      case ioaslot
      when "A1","A2"
        fabric_name = "Fabric A"
      when "B1","B2"
        fabric_name = "Fabric B"
      when "C1","C2"
        fabric_name = "Fabric C"
      end
      logger.debug "Fabric Name: #{fabric_name}"
      bladeModel = ""
      fullBladeModelList.each do|model|
        if model.to_s == serverModel.to_s
          bladeModel = "Full"
          break
        end
      end
      halfBladeModelList.each do|model|
        if model.to_s == serverModel.to_s
          bladeModel = "Half"
          break
        end
      end
      quaterBladeModelList.each do|model|
        if model.to_s == serverModel.to_s
          bladeModel = "Quater"
          break
        end
      end
      fx2_quater_blade_model_list.each do|model|
        if model.to_s == serverModel.to_s
          bladeModel = "FX2_Quater"
          break
        end
      end
      fx2_half_blade_model_list.each do|model|
        if model.to_s == serverModel.to_s
          bladeModel = "FX2_Half"
          break
        end
      end
      fx2_full_blade_model_list.each do|model|
        if model.to_s == serverModel.to_s
          bladeModel = "FX2_Full"
          break
        end
      end
      interfaceLocationList = []
      logger.debug("Blade Model: #{bladeModel}")
      logger.debug("Fabric Name: #{fabric_name}")
      logger.debug("Server NIC Type: #{server_nic_type[fabric_name]}")
      # For M620 server with Quad-Port card, two locations each needs to be configured
      if  (bladeModel == "Full" and server_nic_type["#{fabric_name}"] == 2)
        logger.debug("Inside full slot with dual port mode")
        intLoc1 = "0/#{slot}"
        interfaceLoc1 = "Tengigabitethernet#{intLoc1}"
        #self.class.const_set(InterfaceLoc1,"Tengigabitethernet#{intLoc1})
        slotoperation = slot.to_i + 8
        intLoc2 = "0/#{slotoperation}"
        interfaceLoc2 = "Tengigabitethernet#{intLoc2}"
        interfaceLocationList.push(interfaceLoc1)
        interfaceLocationList.push(interfaceLoc2)
        logger.debug("Interface location list in full server port mode: #{interfaceLocationList}")
      end
      if  (bladeModel == "Full" and server_nic_type["#{fabric_name}"] == 4)
        logger.debug("Inside full slot with quad port mode")
        intLoc1 = "0/#{slot}"
        interfaceLoc1 = "Tengigabitethernet#{intLoc1}"
        #self.class.const_set(InterfaceLoc1,"Tengigabitethernet#{intLoc1})
        slotoperation = slot.to_i + 16
        intLoc2 = "0/#{slotoperation}"
        interfaceLoc2 = "Tengigabitethernet#{intLoc2}"
        interfaceLocationList.push(interfaceLoc1)
        interfaceLocationList.push(interfaceLoc2)
        logger.debug("Interface location list in full server port mode: #{interfaceLocationList}")

      end
      if  (bladeModel == "Half" and server_nic_type["#{fabric_name}"] == 4)
        logger.debug("Inside half slot with quad port mode")
        intLoc1 = "0/#{slot}"
        interfaceLoc1 = "Tengigabitethernet#{intLoc1}"
        #self.class.const_set(InterfaceLoc1,"Tengigabitethernet#{intLoc1})
        slotoperation = slot.to_i + 16
        intLoc2 = "0/#{slotoperation}"
        interfaceLoc2 = "Tengigabitethernet#{intLoc2}"
        interfaceLocationList.push(interfaceLoc1)
        interfaceLocationList.push(interfaceLoc2)
        logger.debug("Interface location list in quad port mode: #{interfaceLocationList}")

      end
      if  (bladeModel == "Half" and server_nic_type["#{fabric_name}"] == 2)
        if ioa.match(/cisconexus/)
          fex_interface = ASM::Util.get_cisco_nexus_fex_interfaces(configured_blade_switch_facts[ioa], ioaslot, slot)
          interfaceLocationList.push(fex_interface)
        else
          intLoc = "0/#{slot}"
          interfaceLoc = "Tengigabitethernet#{intLoc}"
          interfaceLocationList = interfaceLocationList.push(interfaceLoc)
        end

      end

      if  bladeModel == "Quater"
        if ioaslot == "A1" || ioaslot == "B1" || ioaslot == "C1"
        if slot =~ /(\d+)(\S+)/
          if $2 == "a"
              intLoc = "0/#{$1}"
          end
          if $2 == "b"
            slotoperation = $1.to_i + 16
            intLoc = "0/#{slotoperation}"
          end
          if $2 == "c"
            slotoperation = $1.to_i + 8
            intLoc = "0/#{slotoperation}"
          end
          if $2 == "d"
            slotoperation = $1.to_i + 24
            intLoc = "0/#{slotoperation}"
          end
          interfaceLoc = "Tengigabitethernet#{intLoc}"
        end
        elsif ioaslot == "A2" || ioaslot == "B2" || ioaslot == "C2"
          if slot =~ /(\d+)(\S+)/
            if $2 == "a"
              slotoperation = $1.to_i + 16
              intLoc = "0/#{slotoperation}"
            end
            if $2 == "b"
              intLoc = "0/#{$1}"
            end
            if $2 == "c"
              slotoperation = $1.to_i + 24
              intLoc = "0/#{slotoperation}"
            end
            if $2 == "d"
              slotoperation = $1.to_i + 8
              intLoc = "0/#{slotoperation}"
            end
            interfaceLoc = "Tengigabitethernet#{intLoc}"
          end
        end
        
        interfaceLocationList = interfaceLocationList.push(interfaceLoc)
      end

      if  (bladeModel == "FX2_Half" and server_nic_type["#{fabric_name}"] == 4)
        slot_enum = [1,3,5,7]
        intLoc_1 = "0/#{slot_enum[slot.to_i - 1]}"
        intLoc_2 = "0/#{slot_enum[slot.to_i - 1] + 1}"
        interfaceLoc_1 = "Tengigabitethernet#{intLoc_1}"
        interfaceLoc_2 = "Tengigabitethernet#{intLoc_2}"
        interfaceLocationList = interfaceLocationList.push(interfaceLoc_1)
        interfaceLocationList = interfaceLocationList.push(interfaceLoc_2)
      end

      if  (bladeModel == "FX2_Half" and server_nic_type["#{fabric_name}"] == 2)
        slot_enum = [1,3,5,7]
        intLoc = "0/#{slot_enum[slot.to_i - 1]}"
        interfaceLoc = "Tengigabitethernet#{intLoc}"
        interfaceLocationList = interfaceLocationList.push(interfaceLoc)
      end

      if  (bladeModel == "FX2_Quater" and server_nic_type["#{fabric_name}"] == 2)
        slot_enum = [1,3,5,7]
        intLoc = "0/#{slot_enum[slot.to_i - 1]}"
        interfaceLoc = "Tengigabitethernet#{intLoc}"
        interfaceLocationList = interfaceLocationList.push(interfaceLoc)
      end
      logger.debug "A-- IOA #{ioa} interfaceLocationList #{interfaceLocationList}"
      retVal.push([ioa, interfaceLocationList,ioaslot])
    end
    retVals = { "#{serviceTag}" => retVal }
    logger.debug "A-- #{retVals}"
    return retVals
  end
end
