=begin
     This class will provide the information of the swtich and the connected port information
     support is added for the rack and the blade server

     TODO: Need to extend the support for the SAN server (Brocade)
=end

require 'pp'
require 'asm/discoverswitch'
require 'asm/rack_server_switch_information'
require 'asm/blade_server_switch_information'
require 'asm/san_switch_information'
require 'asm/wsman'

class Get_switch_information
  def initialize ()
    # Check the blade server type
    #@serverinformation= serverinfo
    #@switchinformation = switchinfo
  end

  def get_info(service_deployment,ser_info,sw_info,logger,server_nic_type=nil,server_vlan_info=nil,server_type=nil,server_already_deployed_flag=false,configured_blade_switch_facts={})
    switchinfolist = []
    switchinfohash = {}
    logger.debug("Server Type: #{server_type}")
    ser_info.each do |nodename,sinfo|
      server_model = sinfo['model']
      logger.debug("Server model: #{server_model}")
      is_stacked = (sinfo['is_stacked'] || false)
      if server_type == "rack"
        switchinfohash = rack_server_switch_info(service_deployment,nodename,sinfo,sw_info,logger,server_nic_type,server_vlan_info,server_already_deployed_flag)
      elsif (server_type == "blade" and is_stacked)
        switchinfohash = rack_server_switch_info(service_deployment,nodename,sinfo,sw_info,logger,server_nic_type,server_vlan_info,server_already_deployed_flag)
      elsif server_type == "blade"
        switchinfohash = blade_server_switch_info(nodename,sinfo,sw_info,logger,server_nic_type,configured_blade_switch_facts)
        if switchinfohash.length() > 0
          switchinfohash.keys().each do |macaddress|
          end
        end
      end
      switchinfolist.push(switchinfohash)
    end
    return switchinfolist
  end
  
  def get_san_info(ser_info,sw_info,wwpns, compellent_contollers, is_fcoe_enabled, logger)
    switchinfolist = []
    switchinfohash = {}
    ser_info.each do |nodename,sinfo|
      switchinfohash = san_switch_info(nodename,sinfo, sw_info, wwpns, 
        compellent_contollers, is_fcoe_enabled, logger)
      logger.debug"switchinfohash: #{switchinfohash}"
      switchinfolist.push(switchinfohash)
      logger.debug"switchinfolist: #{switchinfolist}"
    end
    return switchinfolist
  end
  

  def blade_server_switch_info(nname,server,swinfo,logger,server_nic_type,configured_blade_switch_facts)
    bladeObj=Blade_server_switch_information.new(nname,server,swinfo)
    serverinformation=bladeObj.identify_switch_ports(swinfo,logger,server_nic_type,configured_blade_switch_facts)
    pp serverinformation
    return serverinformation
  end

  def san_switch_info(nname,server,swinfo,wwpns,compellent_contollers, is_fcoe_enabled, logger)
    bladeObj=San_switch_information.new(nname,server,swinfo)
    serverinformation=bladeObj.identify_switch_ports(compellent_contollers,logger)
    if is_fcoe_enabled
      servermacaddress=bladeObj.search_fcoe_server_Macaddress(wwpns,compellent_contollers,logger)
    else
    servermacaddress=bladeObj.search_server_Macaddress(wwpns,compellent_contollers,logger)
    end
    return servermacaddress
  end

  def rack_server_switch_info(service_deployment,nname,sinfo,switchinfo,logger,server_nic_type,server_vlan_info,server_already_deployed_flag)
    rackObj=Rack_server_switch_information.new(nname,sinfo,switchinfo)
    serverinformation=rackObj.identify_switch_ports(logger)
    
    configured_interfaces = get_configured_interfaces(server_nic_type,server_vlan_info,sinfo['mac_addresses'],logger)
    # Validate the connectivity only for interfaces on which VLAN is requested
    servermacaddress=rackObj.search_server_Macaddress(logger,configured_interfaces)
    
    logger.debug("Server MAC Address: #{servermacaddress}")
    if server_already_deployed_flag
      # Need to skip the reboot operation in case the server is already deployed
      return servermacaddress
    end
    # Check if all the
    server_mac_address_count = servermacaddress.count
    if configured_interfaces.count != server_mac_address_count
      logger.debug "Server #{nname} is not updated, need to run the discovery for these"
      # Reboot the server
      endpoint = { 
        :host => sinfo['idrac_ip'],
        :user => sinfo['idrac_username'],
        :password => sinfo['idrac_password']
      }
      ASM::WsMan.reboot(endpoint, logger)
      sleep(60)
      # Initiate the discovery of the switches
      discoverallswitch = Discoverswitch.new(switchinfo,service_deployment)
      resp = discoverallswitch.discoverswitch(logger)
      logger.debug "resp :: #{resp}"
      # Need to run the fact search once again
      serverinfo=rackObj.identify_switch_ports(logger)
      servermacaddress=rackObj.search_server_Macaddress(logger,configured_interfaces)
      server_mac_address_count=sinfo["mac_addresses"].length()
      if configured_interfaces.count != server_mac_address_count
        logger.debug "#{nname}:Not able to identify the server information for all interfaces, seems it is not connected"
      end
    end

    return servermacaddress
  end
  
  def get_configured_interfaces(server_nic_type,server_vlan_info,macArray,logger)
    # Using server vlan info, get fabrics where vlans needs to be configured
    fabrics = []
    configured_interfaces = []
    fabric_enum = []
    fabric_index = {}
    ("A".."Z").each_with_index do |char,index|
      fabric_enum[index] = "Fabric #{char}"
      fabric_index["Fabric #{char}"] = index
    end

    connected_card_ports = {}
    server_vlan_info.each do |card,card_info|
      card_info.each do |interface,interface_info|
        tagged_vlan = (interface_info['tagged_vlans'] || interface_info['tagged'])
        untagged_vlan = (interface_info['untagged_vlans'] || interface_info['untagged'] )
        if (tagged_vlan.nil? or tagged_vlan.length == 0) and ( untagged_vlan.nil? or untagged_vlan.length == 0)
          logger.debug "Card #{card}, port #{interface} do not have vlans"
        else
          logger.debug "Card #{card}, port #{interface} needs to be configured"
          if card.is_a?(Fixnum)
            connected_card_ports[fabric_enum[card.to_i]] ||= []
            logger.debug "Inside the default rack loop: #{card}"
            fabrics.push(fabric_enum[card.to_i]) if !fabrics.include?(fabric_enum[card.to_i])
            connected_card_ports[fabric_enum[card.to_i]].push(interface.scan(/\d+/).flatten.first.to_i)
          else
            connected_card_ports[card] ||= []
            logger.debug("Inside blade loop #{card}")
            fabrics.push(card) if !fabrics.include?(card)
            connected_card_ports[card].push(interface.scan(/\d+/).flatten.first.to_i)
          end
        end
      end
    end

    logger.debug "Fabrics that needs to be configured: #{fabrics}"
    logger.debug "Connected port information: #{connected_card_ports}"

    interfaces = macArray.keys.sort
    logger.debug("Mac array info: #{interfaces}")

    slots = []
    slot_interface = {}
    integrated_slot = []
    embedded_slot = []
    additional_slot = []
    additional_chassis_slot = []
    additional_mezz_slot = []
    integrated_slot_interface = {}
    embedded_slot_interface = {}
    additional_slot_interface = {}
    additional_chassis_slot_interface = {}
    additional_mezz_slot_interface = {}
      
    interfaces.each do |interface|
      logger.debug("interface: #{interface}")
      interface_info = interface.match(/NIC.(Slot|Embedded|Integrated|ChassisSlot|Mezzanine).(\d+[B-C]*)-(\d+)-(\d+)/)
      integrated_slot.push("#{interface_info[2]}") if interface_info[1] == "Integrated"
      embedded_slot.push("#{interface_info[2]}") if interface_info[1] == "Embedded"
      additional_slot.push("#{interface_info[2]}") if interface_info[1] == "Slot"
      additional_chassis_slot.push("#{interface_info[2]}") if interface_info[1] == "ChassisSlot"
      additional_mezz_slot.push("#{interface_info[2]}") if interface_info[1] == "Mezzanine"
      
      integrated_slot_interface["#{interface_info[2]}"] = interface_info[1] if interface_info[1] == "Integrated"
      embedded_slot_interface["#{interface_info[2]}"] = interface_info[1] if interface_info[1] == "Embedded"
      additional_slot_interface["#{interface_info[2]}"] = interface_info[1] if interface_info[1] == "Slot"
      additional_chassis_slot_interface["#{interface_info[2]}"] = interface_info[1] if interface_info[1] == "ChassisSlot"
      additional_mezz_slot_interface["#{interface_info[2]}"] = interface_info[1] if interface_info[1] == "Mezzanine"
    end
    #slots = slots.uniq.sort
    integrated_slot = integrated_slot.uniq.sort
    embedded_slot = embedded_slot.uniq.sort
    additional_slot = additional_slot.uniq.sort
    additional_chassis_slot = additional_chassis_slot.uniq.sort
    additional_mezz_slot = additional_mezz_slot.uniq.sort

    # Integrated NICS first and then then additional slot
    logger.debug("Integrated slots where MAC address is retrieved :#{integrated_slot}")
    logger.debug("Embedded slots where MAC address is retrieved :#{embedded_slot}")
    logger.debug("Additional slots where MAC address is retrieved :#{additional_slot}")
    logger.debug("Additional chassis slots where MAC address is retrieved :#{additional_chassis_slot}")
    logger.debug("Additional mezzanine slots where MAC address is retrieved :#{additional_mezz_slot}")
    
    slots = integrated_slot.concat(embedded_slot).concat(additional_slot).concat(additional_chassis_slot).concat(additional_mezz_slot)
    # Need to pick the slots based on fabric enums
    #.first(fabrics.length)

    logger.debug("Slot information: #{slots}")
    logger.debug("Fabric Index: #{fabric_index}")
    fabrics.each_with_index do |fabric,index|
      logger.debug("Fabric: #{fabric}, integer flag: #{fabric.is_a?(Fixnum)}")
      ['0','1','2'].include?(fabric) ? f_index = fabric.to_i : f_index = fabric_index[fabric]
      logger.debug("F_Index: #{f_index}")
      slot_name = slots[f_index]
      if slot_name.nil?
        logger.debug("Slot name is nil")
        # Seems some networks are disabled or skipped
        (0..2).each do |possible_slots|
          slot_name = slots[possible_slots]
          break if !slot_name.nil?
        end
      end
      logger.debug("Slot Name: #{slot_name}")
      if ['0','1','2'].include?(fabric)
        nic_count = server_nic_type["#{fabric_enum[fabric.to_i]}"]
      else
        nic_count = server_nic_type["#{fabric}"]
      end
      suffix = "Slot"
      (1..nic_count).each do |count|
        logger.debug("Connected port for fabric #{fabric}: #{connected_card_ports[fabric]}")
        next if !connected_card_ports[fabric].include?(count)
        if !integrated_slot_interface["#{slot_name}"].nil? && ( fabric == "Fabric A" || fabric == '0' )
          suffix = "Integrated"
          integrated_slot_interface.delete("#{slot_name}") unless (fabric == "Fabric A" and count != nic_count)
        elsif !embedded_slot_interface["#{slot_name}"].nil? && ( fabric == "Fabric A" || fabric == '0' )
          suffix = "Embedded"
          embedded_slot_interface.delete("#{slot_name}") unless (fabric == "Fabric A" and count != nic_count)
        else
          if !additional_slot_interface["#{slot_name}"].nil?
            suffix = "Slot"
          end
          if !additional_chassis_slot_interface["#{slot_name}"].nil?
            suffix = "ChassisSlot"
          end
          if !additional_mezz_slot_interface["#{slot_name}"].nil?
            suffix = "Mezzanine"
          end
        end

        if suffix == 'Embedded'
          int_name = "NIC.#{suffix}.#{count}-#{slot_name}-1"
        else
          int_name = "NIC.#{suffix}.#{slot_name}-#{count}-1"
        end
        configured_interfaces.push(int_name)
      end
    end
    logger.debug "Configured Interfaces: #{configured_interfaces}"
    configured_interfaces
  end
  
  def get_fabic_configured_interfaces(server_nic_type,server_vlan_info,macArray,logger)
    # Using server vlan info, get fabrics where vlans needs to be configured
    fabrics = []
    configured_interfaces = []

    fabric_enum = []
    fabric_index = {}
    ("A".."Z").each_with_index do |char,index|
      fabric_enum[index] = "Fabric #{char}"
      fabric_index["Fabric #{char}"] = index
    end

    server_vlan_info.each do |card,card_info|
      logger.debug("Card: #{card}")
      card_info.each do |interface,interface_info|
        tagged_vlan = interface_info['tagged_vlans']
        untagged_vlan = interface_info['untagged_vlans']
        if (tagged_vlan.nil? or tagged_vlan.length == 0) and ( untagged_vlan.nil? or untagged_vlan.length == 0)
          logger.debug "Card #{card}, port #{interface} do not have vlans"
        else
          logger.debug "Card #{card}, port #{interface} needs to be configured"
          fabrics.push(fabric_enum[card.to_i]) if !fabrics.include?(fabric_enum[card.to_i])
        end
      end
    end

    logger.debug "Fabrics that needs to be configured: #{fabrics}"
    interfaces = macArray.keys.sort
    slots = []
    integrated_slots = []
    embedded_slots = []
    additional_slots = []
    additional_chassis_slots = []

    integrated_slot_interface = {}
    embedded_slot_interface = {}
    additional_slot_interface = {}
    additional_chassis_slot_interface = {}

    integrated_slot_interfaces = {}
    embedded_slot_interfaces = {}
    additional_slot_interfaces = {}
    additional_chassis_slot_interfaces = {}
      
    interfaces.each do |interface|
      interface_info = interface.match(/NIC.(Slot|Embedded|Integrated|ChassisSlot).(\d+)-(\d+)-(\d+)/)
      integrated_slots.push(interface_info[2]) if interface_info[1] == "Integrated"
      embedded_slots.push(interface_info[2]) if interface_info[1] == "Embedded"
      additional_slots.push(interface_info[2]) if interface_info[1] == "Slot"
      additional_chassis_slots.push(interface_info[2]) if interface_info[1] == "ChassisSlot"
      
      integrated_slot_interface["#{interface_info[2]}"] = interface_info[1] if interface_info[1] == "Integrated"
      embedded_slot_interface["#{interface_info[2]}"] = interface_info[1] if interface_info[1] == "Embedded"
      additional_slot_interface["#{interface_info[2]}"] = interface_info[1] if interface_info[1] == "Slot"
      additional_chassis_slot_interface["#{interface_info[2]}"] = interface_info[1] if interface_info[1] == "ChassisSlot"

      integrated_slot_interfaces["#{interface_info[2]}"] ||= []
      embedded_slot_interfaces["#{interface_info[2]}"] ||= []
      additional_slot_interfaces["#{interface_info[2]}"] ||= []
      additional_chassis_slot_interfaces["#{interface_info[2]}"] ||= []
        
      integrated_slot_interfaces["#{interface_info[2]}"].push(macArray[interface]) if interface_info[1] == "Integrated"
      embedded_slot_interfaces["#{interface_info[2]}"].push(macArray[interface]) if interface_info[1] == "Embedded"
      additional_slot_interfaces["#{interface_info[2]}"].push(macArray[interface]) if interface_info[1] == "Slot"
      additional_chassis_slot_interfaces["#{interface_info[2]}"].push(macArray[interface]) if interface_info[1] == "ChassisSlot"
    end
    
    integrated_slots = integrated_slots.uniq.sort
    embedded_slots = embedded_slots.uniq.sort
    additional_slots = additional_slots.uniq.sort
    additional_chassis_slots = additional_chassis_slots.uniq.sort
    slots = integrated_slots.concat(embedded_slots).concat(additional_slots).concat(additional_chassis_slots)
    #first(fabrics.length)

    logger.debug("Integrated slot interfaces :#{integrated_slot_interfaces}")
    logger.debug("Embedded slot interfaces :#{embedded_slot_interfaces}")
    # For wave3 servers Embedded NICs in fabric A are shown as NIC.Embedded.1-1-1 and NIC.Embedded.2-1-1
    # As per the existing workflow, they are treated as interface in two different slots
    if embedded_slot_interfaces.keys.select { |x| ['1','2'].include?(x) } == ["1", "2"]
      embedded_slot_interfaces['1'].concat(embedded_slot_interfaces['2'])
      embedded_slot_interfaces.delete('2')
    end
    logger.debug("Embedded slot interfaces after merge :#{embedded_slot_interfaces}")
    logger.debug("Additional slot interfaces :#{additional_slot_interfaces}")
    logger.debug("Additional chassis slot interfaces: #{additional_chassis_slot_interfaces}")
    logger.debug("Slots: #{slots}")

    interface_info = {}
    fabrics.each_with_index do |fabric,index|
      f_index = fabric_index[fabric]
      slot_name = slots[f_index]
      if integrated_slot_interfaces[slot_name] and integrated_slot_interfaces[slot_name].size > 0
        interface_info[fabric] = integrated_slot_interfaces[slot_name]
        integrated_slot_interfaces.delete(slot_name)
      elsif embedded_slot_interfaces[slot_name] and embedded_slot_interfaces[slot_name].size > 0
        interface_info[fabric] = embedded_slot_interfaces[slot_name]
        embedded_slot_interfaces.delete(slot_name)        
      elsif additional_slot_interfaces[slot_name] and additional_chassis_slot_interfaces[slot_name].size > 0
        interface_info[fabric] = additional_slot_interfaces[slot_name]
      else
        interface_info[fabric] = additional_chassis_slot_interfaces[slot_name]
      end
    end
    logger.debug("Interface info : #{interface_info}")
    interface_info
  end
  

end

