require 'json'

class Rack_server_switch_information
  def initialize(servicetag,sinfo,swinfo)
    @serverinfo=sinfo
    @switchinfo=swinfo
    @ServiceTag=servicetag
    @mainremotehash={}
    @mainportchhash={}

    @matchedHash={}

  end

  def identify_switch_ports(logger)
    logger.debug "******** #{@switchinfo} *************"
    @switchinfo.keys.each do |certname|
      logger.debug "certname :: #{certname}"
      valuesHash = ASM::Util.facts_find(certname, logger)
      remoteHash=valuesHash["remote_device_info"]
      if !remoteHash
        remoteHash=valuesHash["remotedeviceinfo"]
      end
      portChHash=valuesHash["port_channels"]
      if !portChHash
        portChHash=valuesHash["portchannelmap"]
      end
      newremotehash = JSON.parse(remoteHash)
      @mainremotehash.store(certname,newremotehash)
      newportchhash = JSON.parse(portChHash)
      @mainportchhash.store(certname,newportchhash)

    end
  end
end

def search_server_Macaddress_force10(certname,mac,logger)
  interface_found="false"

  cert_port=[]
  intfLoc1=[]
  ports=[]
  cert_ports=[]
  @mainremotehash[certname].keys.each do |intf|
    newremotehash1=@mainremotehash[certname]
    intfHash = newremotehash1[intf]
    remote_mac = intfHash["remote_mac"]
    if !remote_mac
      remote_mac = intfHash["mac_address"]
    end
    intfLoc=intf
    logger.debug "search_server_Macaddress_force10: intfLoc: #{intfLoc}  mac: #{mac} remote_mac: #{remote_mac.upcase} "
    if mac.include?(remote_mac.upcase)
      logger.debug "search_server_Macaddress_force10: Matched intfLoc: #{intfLoc}  macArray: #{mac} remote_mac: #{remote_mac.upcase} "
      lag=getLAGFromIntf(intf,certname)
      if !lag.empty?
        ports=intfLoc1.push(lag)
      else
        ports=intfLoc1.push(intfLoc)
      end
      interface_found="true"
    end
  end
  if interface_found == "true"
    cert_port.push(certname)
    cert_port.push(ports)
    cert_ports.push(cert_port)
    #logger.debug "search_server_Macaddress_force10: Adding in matchedhash remote_mac.: #{remote_mac} and  cert_port: #{cert_port} and cert_ports: #{@cert_ports} "
    @matchedHash.store(mac.upcase, cert_ports)
  end

end

def search_server_Macaddress_cisconexus(certname,mac,logger)
  interface_found="false"

  cert_port=[]
  intfLoc1=[]
  ports=[]
  cert_ports=[]
  logger.debug("Remote Hash: #{@mainremotehash[certname]}")
  @mainremotehash[certname].keys.each do |intf|
    logger.debug("intf: #{intf}")
    newremotehash1=@mainremotehash[certname]
    intfHash = newremotehash1[intf]
    remote_mac = intfHash["remote_mac"].gsub('.','')
    intfLoc=intf
    logger.debug "Search server macaddress Cisco Nexus: intfLoc: #{intfLoc}  mac: #{mac} remote_mac: #{remote_mac.upcase} "
    if mac.gsub(':','').include?(remote_mac.upcase)
      logger.debug "Search Macaddress Cisco Nexus: Matched intfLoc: #{intfLoc}  macArray: #{mac} remote_mac: #{remote_mac.upcase} "
      lag=getLAGFromIntf(intf,certname)
      ports=intfLoc1.push(intfLoc)
      interface_found="true"
    end
  end
  if interface_found == "true"
    cert_port.push(certname)
    cert_port.push(ports)
    cert_ports.push(cert_port)
    #logger.debug "search_server_Macaddress_force10: Adding in matchedhash remote_mac.: #{remote_mac} and  cert_port: #{cert_port} and cert_ports: #{@cert_ports} "
    @matchedHash.store(mac.upcase,cert_ports)
  end

end

def search_server_Macaddress_powerconnect(certname, nic_mac, logger)
  interface_found = false
  ports = []
  lldp_macs = @mainremotehash[certname]
  logger.debug " lldp_macs: #{lldp_macs} **************"
  unless nic_mac.nil?
  lldp_macs.each do |remote_mac, location|
    if nic_mac.upcase == remote_mac.upcase
      logger.debug "search_server_Macaddress_powerconnect : location: #{location}  remote_mac: #{remote_mac.upcase} "
      ports.push(location)
      interface_found = true
    end
  end
  else
    logger.debug ">>>> Oddity: nic_mac is nil for certname #{certname}"
  end
  if interface_found
    #FIXME:  Why are these arrays?
    cert_ports = [ [certname, ports] ]
    @matchedHash.store(nic_mac.upcase, cert_ports)
  end

end

public

def search_server_Macaddress(logger,configured_interfaces)
  serviceTag=@ServiceTag
  dataHash= @serverinfo
  macArray= dataHash["mac_addresses"]
  logger.debug "Mac Array: #{macArray.inspect}"
  logger.debug("Interfaces that needs to be configured: #{configured_interfaces}")
  
  configured_interfaces.each do |interface|
    logger.debug("Interface for which MAC address needs to be searched : #{interface}")
    mac = macArray["#{interface}"]
    logger.debug("mac address : #{mac}")
    @interface_found="false"
    @cert_ports=[]
    @mainremotehash.keys.each do |certname|
      logger.debug("Searching for switch #{certname}")
      match = certname.match(/powerconnect/)
      if match
        search_server_Macaddress_powerconnect(certname,mac,logger)
      elsif certname.include?('cisconexus')
        search_server_Macaddress_cisconexus(certname,mac,logger)
      else
        search_server_Macaddress_force10(certname,mac,logger)
      end
    end
  end
  return @matchedHash
end

private

def getLAGFromIntf(intf,certname)
  ports=[]
  @mainportchhash[certname].keys.each do |lag|
    newportchhash2= @mainportchhash[certname]
    ports=[]
    lagHash =  newportchhash2[lag]
    port = lagHash["ports"]
    if port
      port.split(",").each do |p|
        p.match(/(.*)\(/)
        ports.push($1.strip)
      end
    else
      lagHash.split(",").each do |p|
        ports.push(p.strip)
      end
    end
    if ports.include?(intf)
      return lag
    end
  end
  return ""
end

